@-------------------------------------------------------------------------
@  file : syscall.s
@  2003/06/26
@  Copyright (C) 2003  Jun Mizutani <mizutani.jun@nifty.ne.jp>
@-------------------------------------------------------------------------

.ifndef __SYSCALL
__SYSCALL = 1

sys_ni_syscall              = 0x900000
sys_exit                    = 0x900001
sys_fork                    = 0x900002
sys_read                    = 0x900003
sys_write                   = 0x900004
sys_open                    = 0x900005
sys_close                   = 0x900006
sys_ni_syscall              = 0x900007        @ was sys_waitpid
sys_creat                   = 0x900008
sys_link                    = 0x900009
sys_unlink                  = 0x90000A
sys_execve                  = 0x90000B
sys_chdir                   = 0x90000C
sys_time                    = 0x90000D        @ used by libc4
sys_mknod                   = 0x90000E
sys_chmod                   = 0x90000F
sys_lchown16                = 0x900010
sys_ni_syscall              = 0x900011        @ was sys_break
sys_ni_syscall              = 0x900012        @ was sys_stat
sys_lseek                   = 0x900013
sys_getpid                  = 0x900014
sys_mount                   = 0x900015
sys_oldumount               = 0x900016        @ used by libc4
sys_setuid16                = 0x900017
sys_getuid16                = 0x900018
sys_stime                   = 0x900019
sys_ptrace                  = 0x90001A
sys_alarm                   = 0x90001B        @ used by libc4
sys_ni_syscall              = 0x90001C        @ was sys_fstat
sys_pause                   = 0x90001D
sys_utime                   = 0x90001E        @ used by libc4
sys_ni_syscall              = 0x90001F        @ was sys_stty
sys_ni_syscall              = 0x900020        @ was sys_getty
sys_access                  = 0x900021
sys_nice                    = 0x900022
sys_ni_syscall              = 0x900023        @ was sys_ftime
sys_sync                    = 0x900024
sys_kill                    = 0x900025
sys_rename                  = 0x900026
sys_mkdir                   = 0x900027
sys_rmdir                   = 0x900028
sys_dup                     = 0x900029
sys_pipe                    = 0x90002A
sys_times                   = 0x90002B
sys_ni_syscall              = 0x90002C        @ was sys_prof
sys_brk                     = 0x90002D
sys_setgid16                = 0x90002E
sys_getgid16                = 0x90002F
sys_ni_syscall              = 0x900030        @ was sys_signal
sys_geteuid16               = 0x900031
sys_getegid16               = 0x900032
sys_acct                    = 0x900033
sys_umount                  = 0x900034
sys_ni_syscall              = 0x900035        @ was sys_lock
sys_ioctl                   = 0x900036
sys_fcntl                   = 0x900037
sys_ni_syscall              = 0x900038        @ was sys_mpx
sys_setpgid                 = 0x900039
sys_ni_syscall              = 0x90003A        @ was sys_ulimit
sys_ni_syscall              = 0x90003B        @ was sys_olduname
sys_umask                   = 0x90003C
sys_chroot                  = 0x90003D
sys_ustat                   = 0x90003E
sys_dup2                    = 0x90003F
sys_getppid                 = 0x900040
sys_getpgrp                 = 0x900041
sys_setsid                  = 0x900042
sys_sigaction               = 0x900043
sys_ni_syscall              = 0x900044        @ was sys_sgetmask
sys_ni_syscall              = 0x900045        @ was sys_ssetmask
sys_setreuid16              = 0x900046
sys_setregid16              = 0x900047
sys_sigsuspend_wrapper      = 0x900048
sys_sigpending              = 0x900049
sys_sethostname             = 0x90004A
sys_setrlimit               = 0x90004B
sys_old_getrlimit           = 0x90004C        @ used by libc4
sys_getrusage               = 0x90004D
sys_gettimeofday            = 0x90004E
sys_settimeofday            = 0x90004F
sys_getgroups16             = 0x900050
sys_setgroups16             = 0x900051
old_select                  = 0x900052        @ used by libc4
sys_symlink                 = 0x900053
sys_ni_syscall              = 0x900054        @ was sys_lstat
sys_readlink                = 0x900055
sys_uselib                  = 0x900056
sys_swapon                  = 0x900057
sys_reboot                  = 0x900058
old_readdir                 = 0x900059        @ used by libc4
old_mmap                    = 0x90005A        @ used by libc4
sys_munmap                  = 0x90005B
sys_truncate                = 0x90005C
sys_ftruncate               = 0x90005D
sys_fchmod                  = 0x90005E
sys_fchown16                = 0x90005F
sys_getpriority             = 0x900060
sys_setpriority             = 0x900061
sys_ni_syscall              = 0x900062        @ was sys_profil
sys_statfs                  = 0x900063
sys_fstatfs                 = 0x900064
sys_ni_syscall              = 0x900065
sys_socketcall              = 0x900066
sys_syslog                  = 0x900067
sys_setitimer               = 0x900068
sys_getitimer               = 0x900069
sys_newstat                 = 0x90006A
sys_newlstat                = 0x90006B
sys_newfstat                = 0x90006C
sys_ni_syscall              = 0x90006D        @ was sys_uname
sys_ni_syscall              = 0x90006E        @ was sys_iopl
sys_vhangup                 = 0x90006F
sys_ni_syscall              = 0x900070
sys_syscall                 = 0x900071        @ call a syscall
sys_wait4                   = 0x900072
sys_swapoff                 = 0x900073
sys_sysinfo                 = 0x900074
sys_ipc                     = 0x900075
sys_fsync                   = 0x900076
sys_sigreturn_wrapper       = 0x900077
sys_clone_wapper            = 0x900078
sys_setdomainname           = 0x900079
sys_newuname                = 0x90007A
sys_ni_syscall              = 0x90007B
sys_adjtimex                = 0x90007C
sys_mprotect                = 0x90007D
sys_sigprocmask             = 0x90007E
sys_create_module           = 0x90007F
sys_init_module             = 0x900080
sys_delete_module           = 0x900081
sys_get_kernel_syms         = 0x900082
sys_quotactl                = 0x900083
sys_getpgid                 = 0x900084
sys_fchdir                  = 0x900085
sys_bdflush                 = 0x900086
sys_sysfs                   = 0x900087
sys_personality             = 0x900088
sys_ni_syscall              = 0x900089        @ long  _sys_afs_syscall
sys_setfsuid16              = 0x90008A
sys_setfsgid16              = 0x90008B
sys_llseek                  = 0x90008C
sys_getdents                = 0x90008D
sys_select                  = 0x90008E
sys_flock                   = 0x90008F
sys_msync                   = 0x900090
sys_readv                   = 0x900091
sys_writev                  = 0x900092
sys_getsid                  = 0x900093
sys_fdatasync               = 0x900094
sys_sysctl                  = 0x900095
sys_mlock                   = 0x900096
sys_munlock                 = 0x900097
sys_mlockall                = 0x900098
sys_munlockall              = 0x900099
sys_sched_setparam          = 0x90009A
sys_sched_getparam          = 0x90009B
sys_sched_setscheduler      = 0x90009C
sys_sched_getscheduler      = 0x90009D
sys_sched_yield             = 0x90009E
sys_sched_get_priority_max  = 0x90009F
sys_sched_get_priority_min  = 0x9000A0
sys_sched_rr_get_interval   = 0x9000A1
sys_nanosleep               = 0x9000A2
sys_arm_mremap              = 0x9000A3
sys_setresuid16             = 0x9000A4
sys_getresuid16             = 0x9000A5
sys_ni_syscall              = 0x9000A6
sys_query_module            = 0x9000A7
sys_poll                    = 0x9000A8
sys_nfsservctl              = 0x9000A9
sys_setresgid16             = 0x9000AA
sys_getresgid16             = 0x9000AB
sys_prctl                   = 0x9000AC
sys_rt_sigreturn_wrapper    = 0x9000AD
sys_rt_sigaction            = 0x9000AE
sys_rt_sigprocmask          = 0x9000AF
sys_rt_sigpending           = 0x9000B0
sys_rt_sigtimedwait         = 0x9000B1
sys_rt_sigqueueinfo         = 0x9000B2
sys_rt_sigsuspend_wrapper   = 0x9000B3
sys_pread                   = 0x9000B4
sys_pwrite                  = 0x9000B5
sys_chown16                 = 0x9000B6
sys_getcwd                  = 0x9000B7
sys_capget                  = 0x9000B8
sys_capset                  = 0x9000B9
sys_sigaltstack_wrapper     = 0x9000BA
sys_sendfile                = 0x9000BB
sys_ni_syscall              = 0x9000BC
sys_ni_syscall              = 0x9000BD
sys_vfork_wrapper           = 0x9000BE
sys_getrlimit               = 0x9000BF
sys_mmap2                   = 0x9000C0
sys_truncate64              = 0x9000C1
sys_ftruncate64             = 0x9000C2
sys_stat64                  = 0x9000C3
sys_lstat64                 = 0x9000C4
sys_fstat64                 = 0x9000C5
sys_lchown                  = 0x9000C6
sys_getuid                  = 0x9000C7
sys_getgid                  = 0x9000C8
sys_geteuid                 = 0x9000C9
sys_getegid                 = 0x9000CA
sys_setreuid                = 0x9000CB
sys_setregid                = 0x9000CC
sys_getgroups               = 0x9000CD
sys_setgroups               = 0x9000CE
sys_fchown                  = 0x9000CF
sys_setresuid               = 0x9000D0
sys_getresuid               = 0x9000D1
sys_setresgid               = 0x9000D2
sys_getresgid               = 0x9000D3
sys_chown                   = 0x9000D4
sys_setuid                  = 0x9000D5
sys_setgid                  = 0x9000D6
sys_setfsuid                = 0x9000D7
sys_setfsgid                = 0x9000D8
sys_getdents64              = 0x9000D9
sys_pivot_root              = 0x9000DA
sys_mincore                 = 0x9000DB
sys_madvise                 = 0x9000DC
sys_fcntl64                 = 0x9000DD

.endif
